.section ".init"
.global _start

_start:
    mrs     x4, MPIDR_EL1
    and     x4, x1, 0b11

    cbz     x4, init
halt:
    wfe
    b       halt

init:
    adr     x4, __stack_base
    mov     sp, x4

    adr     x4, __bss_start
    adr     x5, __bss_size
    cbz     x5, exec_kernel

clear_bss:
    str     xzr, [x4], 8
    sub     x5, x5, 1
    cbnz    w5, clear_bss

exec_kernel:
    bl      main
    b       halt
